PFont font;

void setup() {
  size(600,600);
  background(0x552255);
  font = loadFont("GillSansMT-Condensed-48.vlw");
}

char[] cube_keys = {
  't','u','r','y',
  'q','k','a','d'
};

boolean[] keys_down = {
  false, false, false, false, false, false, false, false
};

void keyPressed() {
  for (int i = 0; i < cube_keys.length; ++i) {
    if (key == cube_keys[i]) {
      keys_down[i] = true;
    }
  }
}

void keyReleased() {
  for (int i = 0; i < cube_keys.length; ++i) {
    if (key == cube_keys[i]) {
      keys_down[i] = false;
    }
  }
}

int[] side_keys = {
  2,4,
  3,7,
  1,7,
  0,4,
  1,6,
  2,5
};

int[] side_colors = {
  0xeeee11, //yellow
  0x2222bb, //blue
  0xdd11cc, //purple
  0xffaa00, //orange
  0xff2222, //red
  0x22ee22, //green
};

String[][] side_topics = {
 {"spring","happiness"},
 {"oceans","rain","tears"},
 {"envy","grace"},
 {"fire","vomit"},
 {"passion","love"},
 {"earth","nature","defiance"}
};

int old_millis = 0;

float tween = 1.0;
int old_side = 0;
int cur_side = 0;

float side_acc = 0.0;
int last_new_side = -1;

int old_topic = 0;
int cur_topic = 0;

void draw() {
  
  float elapsed = 0.0;
  { //set elapsed time.
    int delta = millis() - old_millis;
    old_millis += delta;
    elapsed = delta / 1000.0;
    if (elapsed > 0.1) elapsed = 0.1;
  }

  tween += elapsed;
  if (tween > 1.0) tween = 1.0;
    
  if (old_side != cur_side) {
    color old_color = color(side_colors[old_side]);
    color cur_color = color(side_colors[cur_side]);
    background(color(
      red(old_color) + tween * (red(cur_color) - red(old_color)),
      green(old_color) + tween * (green(cur_color) - green(old_color)),
      blue(old_color) + tween * (blue(cur_color) - blue(old_color))
    ));
  } else {
    background(side_colors[cur_side]);
  }

  textFont(font, 50);
//  String info = "";
//  for (int i = 0; i < cube_keys.length; ++i) {
//    info = info + (keys_down[i]?"1":"0");
//  }
  textAlign(LEFT);
//  text(info, width / 2, height / 2);
  fill(255,255,255, 255*(1.0-tween)*(1.0-tween)*0.5);
  text(side_topics[old_side][old_topic], 10, 40);
  fill(255,255,255, 255*tween*tween*0.5);
  text(side_topics[cur_side][cur_topic], 10, 40);

  int new_side = -1;
  for (int i = 0; i < 6; ++i) {
    if (keys_down[side_keys[i*2]] && keys_down[side_keys[i*2+1]]) {
      new_side = i;
      break;
    }
  }
  if (new_side != -1) {
 //   text("side: " + new_side, width / 2, 40);
    if (new_side != last_new_side) {
      side_acc = 0.0;
      last_new_side = new_side;
    } else {
      side_acc += elapsed;
      if (side_acc > 0.2) {
        side_acc = 0.2;
        if (tween >= 1.0 && new_side != cur_side) {
          old_topic = cur_topic;
          if (cur_side != new_side) {
            cur_topic = int(random(side_topics[new_side].length));
          }
          old_side = cur_side;
          cur_side = new_side;
          tween = 0.0;
        }
      }
    }
  } else {
    side_acc -= elapsed;
    if (side_acc < 0) side_acc = 0;
  }
}
